# PipeTap

Gtk4 + Vala PipeWire camera control overlay.

This thing is very WIP, report any bugs you found

## THERE ARE A LOT OF HARDCODED VALUES! PLEASE USE MY [LIBCAMERA FORK](https://git.nekocwd.duckdns.org/NekoCWD/libcamera)

## PostmarketOS nightly testing:
1) [Add my nightly repo](https://git.nekocwd.duckdns.org/Administration/Documentation/src/branch/master/install-nightly-repo.md)
2) Install pipetap and libcamera
  ```
  sudo apk add libcamera@nightly libcamera-ipa@nightly libcamera-tools@nightly pipetap@nightly
  ```
3) Reboot
4) Start PipeTap (tap to icon in app launcher)
5) Start camera app (Snapshot/any other pipewire camera app)

## How does it works?
I've modified [libcamera](https://gitlab.com/NekoCWD/libcamera) to export brightness/focus controls.

Pipewire plugin for libcamera exporting this controls as camera node params.

PipeTap use generated bindings for WirePlumber GObject api to communicate with pipewire.

It listening to camera node state changes and opens overlay if cameta in active state.

It controls camera node parameters.
__It can't control v4l2 devices directly!!__

## Screenshots
![Demo](assets/overview.jpg)
